'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

var Direction =
/**
 * @constructor
 * @param {Number} x    The x direction.
 * @param {Number} y    The y direction.
 */
function Direction() {
  var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  _classCallCheck(this, Direction);

  this.x = x;
  this.y = y;
};
Direction.ORIGIN = {
  C: new Direction(0, 0)
};
Direction.CARDINALS = {
  N: new Direction(0, -1),
  E: new Direction(1, 0),
  S: new Direction(0, 1),
  W: new Direction(-1, 0)
};
Direction.ORDINALS = {
  NE: new Direction(1, -1),
  SE: new Direction(1, 1),
  SW: new Direction(-1, 1),
  NW: new Direction(-1, -1)
};
Direction.NEIGHBORS = _objectSpread2(_objectSpread2(_objectSpread2({}, Direction.ORIGIN), Direction.CARDINALS), Direction.ORDINALS);

/**
 * Determines whether a value is a function.
 *
 * @param   {*} val
 * @returns {Boolean}
 */
function isFunction(val) {
  return typeof val === "function";
}
/**
 * Determines whether a value is a symbol.
 *
 * @param   {*} val
 * @returns {Boolean}
 */

function isSymbol(val) {
  return _typeof(val) === "symbol";
}
/**
 * Determines whether a value is defined.
 *
 * @param   {*} val
 * @returns {Boolean}
 */

function isDefined(val) {
  return val !== undefined;
}
/**
 * Returns whether a value is an object.
 *
 * @param  {*} val
 * @return {Boolean}
 */

function isObject(val) {
  return _typeof(val) === "object" && val !== null;
}
/**
 * Determines whether a value is even.
 *
 * @param   {Number} val
 * @returns {Boolean}
 */

function isEven(val) {
  return val % 2 === 0;
}
/**
 * Clamps a value between a minimum and maximum.
 *
 * @param   {Number} val
 * @param   {Number} min
 * @param   {Number} max
 * @returns {Number}
 */

function clamp(val, min, max) {
  if (min < max) {
    return val < min ? min : val > max ? max : val;
  }

  return val < max ? max : val > min ? min : val;
}
/**
 * Wraps a value between a minimum and maximum.
 *
 * @param   {Number} val
 * @param   {Number} min
 * @param   {Number} max
 * @returns {Number}
 */

function wrap(val, min, max) {
  if (min < max) {
    return ((val - min) % (max + 1 - min) + (max + 1 - min)) % (max + 1 - min) + min;
  }

  return ((val - max) % (min + 1 - max) + (min + 1 - max)) % (min + 1 - max) + max;
}
/**
 * Returns an array of entries for objects with two levels of keys.
 *
 * @param   {Object} obj
 * @returns {Array}
 */

function deepEntries(obj) {
  var entries = [];
  Object.entries(obj).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        x = _ref2[0],
        dim = _ref2[1];

    Object.entries(dim).forEach(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          y = _ref4[0],
          value = _ref4[1];

      entries.push([x, y, value]);
    });
  });
  return entries;
}

/**
 * @type {Symbol} The value used to signal a wildcard value in the pattern.
 */

var $ = Symbol("wildcard");
var PatternMatcher = {
  /**
   * Creates a new pattern matcher.
   *
   * @param   {Function} factory
   * @returns {Function}
   */
  create: function create(factory) {
    var symbols = [];

    for (var i = 0; i < factory.length; i++) {
      symbols.push(Symbol(i));
    }

    var pattern = factory.apply(void 0, symbols);
    sanitize(pattern);
    var width = pattern.length;
    var height = pattern[0].length;
    var xOffset = width / -2 | 0;
    var yOffset = height / -2 | 0;
    var nodesBySymbol = {};
    var nodesExact = [];

    for (var x = 0; x < width; x++) {
      for (var y = 0; y < height; y++) {
        var el = pattern[x][y];

        if (el === $) {
          continue;
        }

        if (isSymbol(el)) {
          var _nodesBySymbol$el;

          nodesBySymbol[el] = (_nodesBySymbol$el = nodesBySymbol[el]) !== null && _nodesBySymbol$el !== void 0 ? _nodesBySymbol$el : [];
          nodesBySymbol[el].push({
            x: x + xOffset,
            y: y + yOffset
          });
        } else {
          nodesExact.push({
            x: x + xOffset,
            y: y + yOffset,
            value: el
          });
        }
      }
    }

    return matcherWith({
      nodesExact: nodesExact,
      nodesBySymbol: nodesBySymbol
    });
  }
};

function matcherWith(_ref) {
  var nodesExact = _ref.nodesExact,
      nodesBySymbol = _ref.nodesBySymbol;
  return function (x, y, data) {
    var _iterator = _createForOfIteratorHelper(nodesExact),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var node = _step.value;

        if (data.get(x + node.x, y + node.y) !== node.value) {
          return false;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    var _iterator2 = _createForOfIteratorHelper(Object.getOwnPropertySymbols(nodesBySymbol)),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var symbol = _step2.value;
        var nodes = nodesBySymbol[symbol];
        var val = data.get(x + nodes[0].x, y + nodes[0].y);

        for (var i = 1; i < nodes.length; i++) {
          if (data.get(x + nodes[i].x, y + nodes[i].y) !== val) {
            return false;
          }
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    return true;
  };
}

function sanitize(pattern) {
  if (isEven(pattern.length)) {
    throw Error("Pattern dimensions must be odd");
  }

  var _iterator3 = _createForOfIteratorHelper(pattern),
      _step3;

  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var row = _step3.value;

      if (isEven(row.length)) {
        throw Error("Pattern dimensions must be odd");
      }
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

function getCjsExportFromNamespace (n) {
	return n && n['default'] || n;
}

var merge = createCommonjsModule(function (module) {

  (function (isNode) {
    /**
     * Merge one or more objects 
     * @param bool? clone
     * @param mixed,... arguments
     * @return object
     */
    var Public = function Public(clone) {
      return merge(clone === true, false, arguments);
    },
        publicName = 'merge';
    /**
     * Merge two or more objects recursively 
     * @param bool? clone
     * @param mixed,... arguments
     * @return object
     */


    Public.recursive = function (clone) {
      return merge(clone === true, true, arguments);
    };
    /**
     * Clone the input removing any reference
     * @param mixed input
     * @return mixed
     */


    Public.clone = function (input) {
      var output = input,
          type = typeOf(input),
          index,
          size;

      if (type === 'array') {
        output = [];
        size = input.length;

        for (index = 0; index < size; ++index) {
          output[index] = Public.clone(input[index]);
        }
      } else if (type === 'object') {
        output = {};

        for (index in input) {
          output[index] = Public.clone(input[index]);
        }
      }

      return output;
    };
    /**
     * Merge two objects recursively
     * @param mixed input
     * @param mixed extend
     * @return mixed
     */


    function merge_recursive(base, extend) {
      if (typeOf(base) !== 'object') return extend;

      for (var key in extend) {
        if (typeOf(base[key]) === 'object' && typeOf(extend[key]) === 'object') {
          base[key] = merge_recursive(base[key], extend[key]);
        } else {
          base[key] = extend[key];
        }
      }

      return base;
    }
    /**
     * Merge two or more objects
     * @param bool clone
     * @param bool recursive
     * @param array argv
     * @return object
     */


    function merge(clone, recursive, argv) {
      var result = argv[0],
          size = argv.length;
      if (clone || typeOf(result) !== 'object') result = {};

      for (var index = 0; index < size; ++index) {
        var item = argv[index],
            type = typeOf(item);
        if (type !== 'object') continue;

        for (var key in item) {
          if (key === '__proto__') continue;
          var sitem = clone ? Public.clone(item[key]) : item[key];

          if (recursive) {
            result[key] = merge_recursive(result[key], sitem);
          } else {
            result[key] = sitem;
          }
        }
      }

      return result;
    }
    /**
     * Get type of variable
     * @param mixed input
     * @return string
     *
     * @see http://jsperf.com/typeofvar
     */


    function typeOf(input) {
      return {}.toString.call(input).slice(8, -1).toLowerCase();
    }

    if (isNode) {
      module.exports = Public;
    } else {
      window[publicName] = Public;
    }
  })( module && 'object' === 'object' && module.exports);
});

var clone = function clone(_ref) {
  var x = _ref.x,
      y = _ref.y;
  return {
    x: x,
    y: y
  };
};
var equals = function equals(a, b) {
  return a.x === b.x && a.y === b.y;
};
var intersects = function intersects(v, a, b) {
  return v.x >= a.x && v.x <= b.x && v.y >= a.y && v.y <= b.y;
};

var areaStamp = function areaStamp(_ref) {
  var target = _ref.target,
      replace = _ref.replace,
      area = _ref.area,
      _ref$step = _ref.step,
      step = _ref$step === void 0 ? 1 : _ref$step,
      _ref$attempts = _ref.attempts,
      attempts = _ref$attempts === void 0 ? 1 : _ref$attempts;
  return function (_ref2) {
    var data = _ref2.data,
        random = _ref2.random;
    var range = area.max - area.min;

    var canStamp = function canStamp(x, y, width, height) {
      for (var i = 0; i < height; i++) {
        for (var j = 0; j < width; j++) {
          if (!data.hasElementAt(x + i, y + j) || data.get(x + i, y + j) !== target) {
            return false;
          }
        }
      }

      return true;
    };

    while (attempts > 0) {
      var x = Math.floor(random() * (data.size() - 1) / step) * step + 1;
      var y = Math.floor(random() * (data.size() - 1) / step) * step + 1;
      var width = Math.floor(random() * (range - 1) / step) * step + area.min;
      var height = Math.floor(random() * (range - 1) / step) * step + area.min;

      if (!canStamp(x, y, width, height)) {
        attempts--;
        continue;
      }

      var val = isFunction(replace) ? replace() : replace;

      for (var i = 0; i < height; i++) {
        for (var j = 0; j < width; j++) {
          data.set(x + i, y + j, val);
        }
      }
    }
  };
};

var cellularAutomata = function cellularAutomata(_ref) {
  var born = _ref.born,
      survive = _ref.survive,
      live = _ref.live,
      dead = _ref.dead;
  return function (_ref2) {
    var data = _ref2.data;
    return data.map(function (el, x, y) {
      var neighborCount = 0;
      Object.values(Direction.NEIGHBORS).forEach(function (dir) {
        if (dir.x === 0 && dir.y === 0) {
          return;
        }

        if (data.get(x + dir.x, y + dir.y) === live) {
          neighborCount++;
        }
      });

      if (neighborCount >= born) {
        return live;
      }

      if (neighborCount >= survive && el === live) {
        return live;
      }

      return dead;
    });
  };
};

var floodFill = function floodFill(_ref) {
  var start = _ref.start,
      target = _ref.target,
      replace = _ref.replace,
      _ref$spread = _ref.spread,
      spread = _ref$spread === void 0 ? 1 : _ref$spread,
      _ref$decay = _ref.decay,
      decay = _ref$decay === void 0 ? 1 : _ref$decay;
  return function (_ref2) {
    var data = _ref2.data,
        random = _ref2.random;
    var nodes = [{
      x: start.x,
      y: start.y,
      spread: spread
    }];

    var _loop = function _loop() {
      var el = nodes.pop();

      if (data.get(el.x, el.y) === target) {
        data.set(el.x, el.y, replace);
        Object.values(Direction.CARDINALS).forEach(function (dir) {
          if ((dir.x !== 0 || dir.y !== 0) && random() < el.spread) {
            nodes.push({
              x: el.x + dir.x,
              y: el.y + dir.y,
              spread: el.spread * decay
            });
          }
        });
      }
    };

    while (nodes.length > 0) {
      _loop();
    }
  };
};

var majorityRules = function majorityRules() {
  return function (_ref) {
    var data = _ref.data;
    return data.map(function (el, x, y) {
      var neighborCount = {};
      Object.values(Direction.NEIGHBORS).forEach(function (dir) {
        var el = data.get(x + dir.x, y + dir.y);

        if (!isDefined(el)) {
          return;
        }

        if (!neighborCount[el]) {
          neighborCount[el] = 0;
        }

        neighborCount[el]++;
      });
      var majority = 0;
      var majorityKey;

      for (var _i = 0, _Object$entries = Object.entries(neighborCount); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
            key = _Object$entries$_i[0],
            count = _Object$entries$_i[1];

        if (count > majority) {
          majority = count;
          majorityKey = key;
        }
      }

      return Number(majorityKey);
    });
  };
};

var mazeGrowth = function mazeGrowth(_ref) {
  var start = _ref.start,
      replace = _ref.replace,
      _ref$runFactor = _ref.runFactor,
      runFactor = _ref$runFactor === void 0 ? 0.5 : _ref$runFactor,
      _ref$walkable = _ref.walkable,
      walkable = _ref$walkable === void 0 ? [] : _ref$walkable;
  return function (_ref2) {
    var data = _ref2.data,
        random = _ref2.random;
    var nodes = [{
      x: start.x,
      y: start.y
    }];
    var walkables = Array.isArray(walkable) ? walkable : [walkable];
    var lastDir = null;
    data.set(start.x, start.y, replace);

    var _loop = function _loop() {
      var node = nodes[nodes.length - 1];
      var validDirs = Object.values(Direction.CARDINALS).filter(function (dir) {
        var x = node.x + dir.x * 2; // TODO step

        var y = node.y + dir.y * 2;

        if (!data.hasElementAt(x, y)) {
          return false;
        }

        var el = data.get(x, y);
        return el !== replace && (walkables.length === 0 || walkables.includes(el));
      });

      if (validDirs.length > 0) {
        var dir = validDirs.includes(lastDir) && random() < runFactor ? lastDir : validDirs[random() * validDirs.length | 0];
        var x = node.x + dir.x * 2;
        var y = node.y + dir.y * 2;
        data.set(x, y, replace);
        data.set(x - dir.x, y - dir.y, replace);
        nodes.push({
          x: x,
          y: y
        });
        lastDir = dir;
      } else {
        nodes.pop();
        lastDir = null;
      }
    };

    while (nodes.length > 0) {
      _loop();
    }
  };
};

var Connector = {
  NONE: 0,
  X: 1,
  Y: 2
};
var dungeonRooms = function dungeonRooms(_ref) {
  var wall = _ref.wall,
      floor = _ref.floor,
      _ref$minRoomSize = _ref.minRoomSize,
      minRoomSize = _ref$minRoomSize === void 0 ? 5 : _ref$minRoomSize,
      _ref$maxRoomSize = _ref.maxRoomSize,
      maxRoomSize = _ref$maxRoomSize === void 0 ? 13 : _ref$maxRoomSize,
      _ref$roomAttempts = _ref.roomAttempts,
      roomAttempts = _ref$roomAttempts === void 0 ? 8 : _ref$roomAttempts,
      _ref$connectivity = _ref.connectivity,
      connectivity = _ref$connectivity === void 0 ? 0 : _ref$connectivity,
      runFactor = _ref.runFactor;
  return function (_ref2) {
    var data = _ref2.data,
        random = _ref2.random;
    // TODO : Assert that min and max room size are odd.
    // TODO : Assert that roomAttempts is positive.
    var tempWall = 0;
    var regionIndex = 1; // let evenSize = data.size() % 2 === 0;

    var size = data.size(); // evenSize ? data.size() - 1 : data.size();

    var nextData = data; // TODO data.map(() => tempWall);

    var matcherEntries = [// TODO flip pattern matcher x y
    {
      key: 'westEnd',
      matcher: PatternMatcher.create(function () {
        return [[$, floor, $], [wall, floor, wall], [$, wall, $]];
      })
    }, {
      key: 'eastEnd',
      matcher: PatternMatcher.create(function () {
        return [[$, wall, $], [wall, floor, wall], [$, floor, $]];
      })
    }, {
      key: 'northEnd',
      matcher: PatternMatcher.create(function () {
        return [[$, wall, $], [wall, floor, floor], [$, wall, $]];
      })
    }, {
      key: 'southEnd',
      matcher: PatternMatcher.create(function () {
        return [[$, wall, $], [floor, floor, wall], [$, wall, $]];
      })
    }];
    var effect = areaStamp({
      target: tempWall,
      replace: function replace() {
        return regionIndex++;
      },
      area: {
        min: minRoomSize,
        max: maxRoomSize
      },
      step: 2,
      attempts: roomAttempts
    });
    effect({
      data: data,
      random: random
    });

    for (var x = 1; x < size; x += 2) {
      for (var y = 1; y < size; y += 2) {
        if (nextData.get(x, y) === tempWall) {
          var _effect = mazeGrowth({
            start: {
              x: x,
              y: y
            },
            replace: regionIndex,
            walkable: tempWall,
            runFactor: runFactor
          });

          _effect({
            data: data,
            random: random
          });

          regionIndex++;
        }
      }
    }

    connectRegions(findConnectorNodes());
    prepareData();
    trimEnds(data.match(matcherEntries), matcherEntries);

    function connectRegions(nodes) {
      var regionCount = regionIndex - 1;

      while (regionCount > 1) {
        var index = random() * nodes.length | 0;
        var node = nodes.splice(index, 1)[0];
        var north = nextData.get(node.row - 1, node.col);
        var south = nextData.get(node.row + 1, node.col);
        var east = nextData.get(node.row, node.col + 1);
        var west = nextData.get(node.row, node.col - 1);

        if (isConnectorNode(node.row, node.col) !== Connector.NONE) {
          if (node.type === Connector.Y) {
            nextData.set(node.row, node.col, south);

            var _effect2 = floodFill({
              // TODO stay in bounds
              start: {
                x: node.row,
                y: node.col
              },
              target: south,
              replace: north
            });

            _effect2({
              data: data,
              random: random
            });

            regionCount--;
          } else if (node.type === Connector.X) {
            nextData.set(node.row, node.col, east);

            var _effect3 = floodFill({
              // TODO stay in bounds
              start: {
                x: node.row,
                y: node.col
              },
              target: east,
              replace: west
            });

            _effect3({
              data: data,
              random: random
            });

            regionCount--;
          }
        } else if (north === south && east === west && random() < connectivity) {
          // TODO Check for connectors on both sides.
          nextData.set(node.row, node.col, floor);
        }
      }
    }

    function findConnectorNodes() {
      var nodes = [];

      for (var i = 1; i < size - 1; i++) {
        for (var j = 1; j < size - 1; j++) {
          var type = isConnectorNode(i, j);

          if (type !== Connector.NONE) {
            nodes.push({
              row: i,
              col: j,
              type: type
            });
          }
        }
      }

      return nodes;
    }

    function isConnectorNode(x, y) {
      if (nextData.get(x, y) !== tempWall) {
        return Connector.NONE;
      }

      var north = nextData.get(x - 1, y);
      var south = nextData.get(x + 1, y);
      var east = nextData.get(x, y + 1);
      var west = nextData.get(x, y - 1);

      if (north !== south && north !== tempWall && south !== tempWall) {
        return Connector.Y;
      }

      if (east !== west && east !== tempWall && west !== tempWall) {
        return Connector.X;
      }

      return Connector.NONE;
    }

    function prepareData() {
      for (var i = 0; i < size; i++) {
        for (var j = 0; j < size; j++) {
          nextData.set(i, j, nextData.get(i, j) === tempWall ? wall : floor);
        }
      } // if (evenSize) {
      // 	for (let i = 0; i < size + 1; i++) {
      // 		nextData[size][i] = nextData[i][size] = wall;
      // 	}
      // }

    }

    function getExitNode(_ref3) {
      var key = _ref3.key,
          x = _ref3.x,
          y = _ref3.y;
      var dx = key === 'eastEnd' ? 1 : key === 'westEnd' ? -1 : 0;
      var dy = key === 'northEnd' ? 1 : key === 'southEnd' ? -1 : 0;
      return {
        key: key,
        x: x + dx,
        y: y + dy
      };
    }

    function trimEnds(nodes, matcherEntries) {
      for (var i = 0; i < nodes.length; i++) {
        var node = nodes[i];
        var exit = getExitNode(node);
        nextData.set(node.x, node.y, wall);

        while (exit) {
          node = exit;
          exit = null;

          var _iterator = _createForOfIteratorHelper(matcherEntries),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var _step$value = _step.value,
                  key = _step$value.key,
                  matcher = _step$value.matcher;

              if (matcher(node.x, node.y, nextData)) {
                exit = getExitNode({
                  key: key,
                  x: node.x,
                  y: node.y
                });
                nextData.set(node.x, node.y, wall);
                break;
              }
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
      }
    }
  };
};



var effects = /*#__PURE__*/Object.freeze({
  __proto__: null,
  areaStamp: areaStamp,
  cellularAutomata: cellularAutomata,
  floodFill: floodFill,
  majorityRules: majorityRules,
  mazeGrowth: mazeGrowth,
  dungeonRooms: dungeonRooms
});

var _nodeResolve_empty = {};

var _nodeResolve_empty$1 = /*#__PURE__*/Object.freeze({
  __proto__: null,
  'default': _nodeResolve_empty
});

var require$$0 = getCjsExportFromNamespace(_nodeResolve_empty$1);

var seedrandom = createCommonjsModule(function (module) {
  /*
  Copyright 2014 David Bau.
  
  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions:
  
  The above copyright notice and this permission notice shall be
  included in all copies or substantial portions of the Software.
  
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  
  */
  (function (pool, math) {
    //
    // The following constants are related to IEEE 754 limits.
    //
    // Detect the global object, even if operating in strict mode.
    // http://stackoverflow.com/a/14387057/265298
    var global = (0, eval)('this'),
        width = 256,
        // each RC4 output is 0 <= x < 256
    chunks = 6,
        // at least six RC4 outputs for each double
    digits = 52,
        // there are 52 significant digits in a double
    rngname = 'random',
        // rngname: name for Math.random and Math.seedrandom
    startdenom = math.pow(width, chunks),
        significance = math.pow(2, digits),
        overflow = significance * 2,
        mask = width - 1,
        nodecrypto; // node.js crypto module, initialized at the bottom.
    //
    // seedrandom()
    // This is the seedrandom function described above.
    //

    function seedrandom(seed, options, callback) {
      var key = [];
      options = options == true ? {
        entropy: true
      } : options || {}; // Flatten the seed string or build one from local entropy if needed.

      var shortseed = mixkey(flatten(options.entropy ? [seed, tostring(pool)] : seed == null ? autoseed() : seed, 3), key); // Use the seed to initialize an ARC4 generator.

      var arc4 = new ARC4(key); // This function returns a random double in [0, 1) that contains
      // randomness in every bit of the mantissa of the IEEE 754 value.

      var prng = function prng() {
        var n = arc4.g(chunks),
            // Start with a numerator n < 2 ^ 48
        d = startdenom,
            //   and denominator d = 2 ^ 48.
        x = 0; //   and no 'extra last byte'.

        while (n < significance) {
          // Fill up all significant digits by
          n = (n + x) * width; //   shifting numerator and

          d *= width; //   denominator and generating a

          x = arc4.g(1); //   new least-significant-byte.
        }

        while (n >= overflow) {
          // To avoid rounding up, before adding
          n /= 2; //   last byte, shift everything

          d /= 2; //   right using integer math until

          x >>>= 1; //   we have exactly the desired bits.
        }

        return (n + x) / d; // Form the number within [0, 1).
      };

      prng.int32 = function () {
        return arc4.g(4) | 0;
      };

      prng.quick = function () {
        return arc4.g(4) / 0x100000000;
      };

      prng["double"] = prng; // Mix the randomness into accumulated entropy.

      mixkey(tostring(arc4.S), pool); // Calling convention: what to return as a function of prng, seed, is_math.

      return (options.pass || callback || function (prng, seed, is_math_call, state) {
        if (state) {
          // Load the arc4 state from the given state if it has an S array.
          if (state.S) {
            copy(state, arc4);
          } // Only provide the .state method if requested via options.state.


          prng.state = function () {
            return copy(arc4, {});
          };
        } // If called as a method of Math (Math.seedrandom()), mutate
        // Math.random because that is how seedrandom.js has worked since v1.0.


        if (is_math_call) {
          math[rngname] = prng;
          return seed;
        } // Otherwise, it is a newer calling convention, so return the
        // prng directly.
        else return prng;
      })(prng, shortseed, 'global' in options ? options.global : this == math, options.state);
    } //
    // ARC4
    //
    // An ARC4 implementation.  The constructor takes a key in the form of
    // an array of at most (width) integers that should be 0 <= x < (width).
    //
    // The g(count) method returns a pseudorandom integer that concatenates
    // the next (count) outputs from ARC4.  Its return value is a number x
    // that is in the range 0 <= x < (width ^ count).
    //


    function ARC4(key) {
      var t,
          keylen = key.length,
          me = this,
          i = 0,
          j = me.i = me.j = 0,
          s = me.S = []; // The empty key [] is treated as [0].

      if (!keylen) {
        key = [keylen++];
      } // Set up S using the standard key scheduling algorithm.


      while (i < width) {
        s[i] = i++;
      }

      for (i = 0; i < width; i++) {
        s[i] = s[j = mask & j + key[i % keylen] + (t = s[i])];
        s[j] = t;
      } // The "g" method returns the next (count) outputs as one number.


      (me.g = function (count) {
        // Using instance members instead of closure state nearly doubles speed.
        var t,
            r = 0,
            i = me.i,
            j = me.j,
            s = me.S;

        while (count--) {
          t = s[i = mask & i + 1];
          r = r * width + s[mask & (s[i] = s[j = mask & j + t]) + (s[j] = t)];
        }

        me.i = i;
        me.j = j;
        return r; // For robust unpredictability, the function call below automatically
        // discards an initial batch of values.  This is called RC4-drop[256].
        // See http://google.com/search?q=rsa+fluhrer+response&btnI
      })(width);
    } //
    // copy()
    // Copies internal state of ARC4 to or from a plain object.
    //


    function copy(f, t) {
      t.i = f.i;
      t.j = f.j;
      t.S = f.S.slice();
      return t;
    }
    // flatten()
    // Converts an object tree to nested arrays of strings.
    //

    function flatten(obj, depth) {
      var result = [],
          typ = _typeof(obj),
          prop;

      if (depth && typ == 'object') {
        for (prop in obj) {
          try {
            result.push(flatten(obj[prop], depth - 1));
          } catch (e) {}
        }
      }

      return result.length ? result : typ == 'string' ? obj : obj + '\0';
    } //
    // mixkey()
    // Mixes a string seed into a key that is an array of integers, and
    // returns a shortened string seed that is equivalent to the result key.
    //


    function mixkey(seed, key) {
      var stringseed = seed + '',
          smear,
          j = 0;

      while (j < stringseed.length) {
        key[mask & j] = mask & (smear ^= key[mask & j] * 19) + stringseed.charCodeAt(j++);
      }

      return tostring(key);
    } //
    // autoseed()
    // Returns an object for autoseeding, using window.crypto and Node crypto
    // module if available.
    //


    function autoseed() {
      try {
        var out;

        if (nodecrypto && (out = nodecrypto.randomBytes)) {
          // The use of 'out' to remember randomBytes makes tight minified code.
          out = out(width);
        } else {
          out = new Uint8Array(width);
          (global.crypto || global.msCrypto).getRandomValues(out);
        }

        return tostring(out);
      } catch (e) {
        var browser = global.navigator,
            plugins = browser && browser.plugins;
        return [+new Date(), global, plugins, global.screen, tostring(pool)];
      }
    } //
    // tostring()
    // Converts an array of charcodes to a string
    //


    function tostring(a) {
      return String.fromCharCode.apply(0, a);
    } //
    // When seedrandom.js is loaded, we immediately mix a few bits
    // from the built-in RNG into the entropy pool.  Because we do
    // not want to interfere with deterministic PRNG state later,
    // seedrandom will not call math.random on its own again after
    // initialization.
    //


    mixkey(math.random(), pool); //
    // Nodejs and AMD support: export the implementation as a module using
    // either convention.
    //

    if ( module.exports) {
      module.exports = seedrandom; // When in node.js, try using crypto package for autoseeding.

      try {
        nodecrypto = require$$0;
      } catch (ex) {}
    } else {
      // When included as a plain script, set up Math.seedrandom global.
      math['seed' + rngname] = seedrandom;
    } // End anonymous scope, and pass initial values.

  })([], // pool: entropy pool starts empty
  Math // math: package containing random, pow, and seedrandom
  );
});

/**
 * Creates a pseudo-random number generator with a given seed.
 *
 * @param   {*} [seed]
 * @returns {Function}
 */

function randomWithSeed(seed) {
  return seedrandom(seed, {
    pass: function pass(random, seed) {
      random.seed = seed;
      return random;
    }
  });
}
/**
 * Generates a new seed with a given length.
 *
 * @param   {Number} [length]
 * @returns {String}
 */

function generateSeed() {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 32;
  var random = seedrandom(null);
  var chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
  var result = "";

  for (var i = 0; i < length; i++) {
    result += chars[Math.floor(random() * chars.length)];
  }

  return result;
}
/**
 * Creates a function that returns random values from a weighted distribution.
 *
 * @param   {Array}    entries
 * @param   {Function} random
 * @returns {Function}
 */

function randomFrom(entries, random) {
  var values = entries.map(function (el) {
    return isDefined(el.value) ? el.value : el;
  });
  var weights = entries.map(function (el) {
    return isDefined(el.weight) ? el.weight : 1;
  });
  var intervals = weights.reduce(function (array, val, i) {
    var _array;

    var prev = (_array = array[i - 1]) !== null && _array !== void 0 ? _array : 0;
    array.push(val + prev);
    return array;
  }, []);
  var sum = intervals[intervals.length - 1];
  return function () {
    var r = random() * sum | 0;
    var index = intervals.findIndex(function (_int) {
      return r < _int;
    });
    return values[index];
  };
}

var DataSegment = {
  /**
   * Creates a new data segment object.
   *
   * @param   {Number}   size
   * @param   {Function} random
   * @param   {Array}    [regions]
   * @param   {Object}   [position]
   * @param   {Object}   [bounds]
   * @param   {Object}   [mutations]
   * @returns {Object}
   */
  create: function create(_ref) {
    var _size = _ref.size,
        random = _ref.random,
        regions = _ref.regions,
        position = _ref.position,
        bounds = _ref.bounds,
        mutations = _ref.mutations;
    var data = dataWithSize(_size);
    var muta = mutations !== null && mutations !== void 0 ? mutations : {};
    return {
      get: function get(x, y) {
        if (x >= 0 && x < _size && y >= 0 && y < _size) {
          return data[x][y];
        } else if (regions) {
          var local = localize(bounds, regions, position, x, y);

          if (local) {
            return local.region.data.get(local.x, local.y);
          }
        }
      },
      set: function set(x, y, val) {
        if (x >= 0 && x < _size && y >= 0 && y < _size) {
          data[x][y] = val;
        } else if (regions) {
          var local = localize(bounds, regions, position, x, y);

          if (local) {
            local.region.data.set(local.x, local.y, val);
          }
        }
      },
      mutate: function mutate(x, y, val) {
        if (x >= 0 && x < _size && y >= 0 && y < _size) {
          muta["".concat(x, ",").concat(y)] = val;
          data[x][y] = val;
        } else if (regions) {
          var local = localize(bounds, regions, position, x, y);

          if (local) {
            local.region.data.mutate(local.x, local.y, val);
          }
        }
      },
      each: function each(fn) {
        for (var x = 0; x < _size; x++) {
          for (var y = 0; y < _size; y++) {
            fn(data[x][y], x, y);
          }
        }
      },
      map: function map(fn) {
        return data.map(function (dim, x) {
          return dim.map(function (el, y) {
            return isFunction(fn) ? fn(el, x, y) : fn;
          });
        });
      },
      fill: function fill(val) {
        for (var x = 0; x < _size; x++) {
          for (var y = 0; y < _size; y++) {
            data[x][y] = isFunction(val) ? val(data[x][y], x, y) : val;
          }
        }
      },
      randomize: function randomize(entries) {
        var fn = randomFrom(entries, random);

        for (var x = 0; x < _size; x++) {
          for (var y = 0; y < _size; y++) {
            data[x][y] = fn();
          }
        }
      },
      match: function match(entries) {
        var results = [];

        for (var x = 0; x < _size; x++) {
          for (var y = 0; y < _size; y++) {
            var _iterator = _createForOfIteratorHelper(entries),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var entry = _step.value;

                if (entry.matcher(x, y, this)) {
                  results.push({
                    x: x,
                    y: y,
                    key: entry.key
                  });
                  break;
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
          }
        }

        return results;
      },
      fromArray: function fromArray(array) {
        for (var x = 0; x < _size; x++) {
          for (var y = 0; y < _size; y++) {
            data[x][y] = array[x][y];
          }
        }
      },
      toArray: function toArray() {
        return this.map(function (el) {
          return el;
        });
      },
      hasElementAt: function hasElementAt(x, y) {
        return x >= 0 && x < _size && y >= 0 && y < _size;
      },
      size: function size() {
        return _size;
      },
      mutations: function mutations() {
        return muta;
      }
    };
  }
};

function dataWithSize(size, val) {
  var data = [];

  for (var x = 0; x < size; x++) {
    data[x] = [];

    for (var y = 0; y < size; y++) {
      data[x][y] = val;
    }
  }

  return data;
}

function localize(bounds, regions, position, x, y) {
  var region = regions[position.x][position.y];
  var local = {
    x: position.x,
    y: position.y
  };
  var check = compareIndex(region.data, x);

  while (check !== 0) {
    local.x += check;
    x -= check * region.data.size();
    check = compareIndex(region.data, x);
  }

  if (bounds.x.wrap) {
    local.x = wrap(local.x, bounds.x.min, bounds.x.max);
  }

  check = compareIndex(region.data, y);

  while (check !== 0) {
    local.y += check;
    y -= check * region.data.size();
    check = compareIndex(region.data, y);
  }

  if (bounds.y.wrap) {
    local.y = wrap(local.y, bounds.y.min, bounds.y.max);
  }

  var localRegion = regions[local.x] && regions[local.x][local.y];

  if (localRegion) {
    return {
      region: localRegion,
      x: x,
      y: y
    };
  }

  return null;
}

function compareIndex(data, index) {
  return index < 0 ? -1 : index >= data.size() ? 1 : 0;
}

var Region = {
  /**
   * Creates a new region object.
   *
   * @param   {Object} config
   * @returns {Object}
   */
  create: function create(config) {
    var _config$seed, _config$mutations;

    return {
      position: config.position,
      type: config.type,
      seed: (_config$seed = config.seed) !== null && _config$seed !== void 0 ? _config$seed : JSON.stringify(config.position),
      mutations: (_config$mutations = config.mutations) !== null && _config$mutations !== void 0 ? _config$mutations : {},
      data: []
    };
  }
};

var RegionGenerator = {
  /**
   * Creates a new region generator object.
   *
   * @param   {Array} regionTypes
   * @param   {Array} regions
   * @param   {*}     seed
   * @returns {Object}
   */
  create: function create(_ref) {
    var regionTypes = _ref.regionTypes,
        regions = _ref.regions,
        seed = _ref.seed;
    var selection = regions;
    return {
      get: function get() {
        return _toConsumableArray(selection);
      },
      select: function select(types) {
        types = Array.isArray(types) ? types : [types];
        types.forEach(function (type) {
          if (!regionTypes.includes(type)) {
            throw Error("Invalid region type \"".concat(type, "\" has not been defined"));
          }
        });
        selection = regions.filter(function (region) {
          return types.includes(region.type);
        });
        return this;
      },
      apply: function apply(callback) {
        var nextData = selection.map(function (region) {
          var effect = callback(region);
          var data = region.data;
          var random = randomWithSeed([seed, region.seed]);
          return effect({
            data: data,
            random: random
          });
        });
        selection.forEach(function (region, index) {
          var data = nextData[index];

          if (data) {
            for (var x = 0; x < data.length; x++) {
              for (var y = 0; y < data[x].length; y++) {
                region.data.set(x, y, data[x][y]);
              }
            }
          }
        });
        return this;
      },
      applyTimes: function applyTimes(count, callback) {
        for (var i = 0; i < count; i++) {
          this.apply(callback);
        }

        return this;
      }
    };
  }
};

/**
 * @type {Object} The default world config.
 */

var DEFAULT_CONFIG = {
  bounds: {
    x: {
      min: -Infinity,
      max: Infinity,
      wrap: false
    },
    y: {
      min: -Infinity,
      max: Infinity,
      wrap: false
    }
  },
  position: {
    x: 0,
    y: 0
  },
  seed: null,
  initialData: {},
  regions: {},
  regionSize: 32,
  chooseRegion: function chooseRegion(_ref) {
    var regionTypes = _ref.regionTypes;
    return regionTypes;
  },
  generate: function generate() {}
};
var World = {
  /**
   * Creates a new world object.
   *
   * @param   {Object} config
   * @returns {Object}
   */
  create: function create(config) {
    config = merge.recursive(true, DEFAULT_CONFIG, config);
    sanitize$1(config);

    var _randomWithSeed = randomWithSeed(config.seed),
        seed = _randomWithSeed.seed;

    var position = clone(config.position);
    var data = createDataObject(config);
    return {
      get data() {
        return data;
      },

      get seed() {
        return seed;
      },

      get position() {
        return clone(position);
      },

      get regionTypes() {
        return Object.keys(config.regions);
      },

      get regionSize() {
        return config.regionSize;
      },

      getRegion: function getRegion() {
        var _data$pos$x;

        var pos = applyBounds(arguments.length === 2 ? {
          x: arguments.length <= 0 ? undefined : arguments[0],
          y: arguments.length <= 1 ? undefined : arguments[1]
        } : arguments.length <= 0 ? undefined : arguments[0], config.bounds);
        return pos && ((_data$pos$x = data[pos.x]) === null || _data$pos$x === void 0 ? void 0 : _data$pos$x[pos.y]);
      },
      init: function init(arg) {
        var opt = parseOptions(arg, position);

        for (var x = opt.x.min; x <= opt.x.max; x++) {
          for (var y = opt.y.min; y <= opt.y.max; y++) {
            setRegion(data, {
              x: x,
              y: y
            }, opt, config);
          }
        }
      },
      remove: function remove(arg) {
        var opt = parseOptions(arg, position);

        for (var x = opt.x.min; x <= opt.x.max; x++) {
          for (var y = opt.y.min; y <= opt.y.max; y++) {
            data[x][y] = undefined;
          }
        }
      },
      generate: function generate(arg) {
        var opt = parseOptions(arg, position);
        var regionTypes = Object.keys(config.regions);
        var regions = [];

        for (var x = opt.x.min; x <= opt.x.max; x++) {
          for (var y = opt.y.min; y <= opt.y.max; y++) {
            var pos = {
              x: x,
              y: y
            };
            var reg = this.getRegion(pos);

            if (reg) {
              regions.push(reg);
              initialize(data, pos, config);
            }
          }
        }

        config.generate({
          regions: RegionGenerator.create({
            regionTypes: regionTypes,
            regions: regions,
            seed: seed
          }),
          effects: effects
        });

        for (var _x = opt.x.min; _x <= opt.x.max; _x++) {
          for (var _y = opt.y.min; _y <= opt.y.max; _y++) {
            mutate(data, {
              x: _x,
              y: _y
            }, config);
          }
        }
      },
      move: function move() {
        var dir = arguments.length === 2 ? {
          x: arguments.length <= 0 ? undefined : arguments[0],
          y: arguments.length <= 1 ? undefined : arguments[1]
        } : arguments.length <= 0 ? undefined : arguments[0];

        if (dir.x === 0 && dir.y === 0) {
          return;
        }

        var _config = config,
            bounds = _config.bounds;
        var current = clone(position);
        position.x = (bounds.x.wrap ? wrap : clamp)(position.x + dir.x, bounds.x.min, bounds.x.max);
        position.y = (bounds.y.wrap ? wrap : clamp)(position.y + dir.y, bounds.y.min, bounds.y.max);

        if (equals(position, current)) {
          throw Error("World position out of bounds");
        }
      },
      serialize: function serialize() {
        var _config2 = config,
            bounds = _config2.bounds,
            regionSize = _config2.regionSize;
        var initialData = deepEntries(data).reduce(function (result, _ref2) {
          var _result$x;

          var _ref3 = _slicedToArray(_ref2, 3),
              x = _ref3[0],
              y = _ref3[1],
              region = _ref3[2];

          result[x] = (_result$x = result[x]) !== null && _result$x !== void 0 ? _result$x : {};
          result[x][y] = {
            type: region.type,
            seed: region.seed,
            mutations: region.mutations
          };
          return result;
        }, {});
        return {
          seed: seed,
          position: position,
          bounds: bounds,
          regionSize: regionSize,
          initialData: initialData
        };
      }
    };
  }
};

function sanitize$1(_ref4) {
  var bounds = _ref4.bounds,
      regions = _ref4.regions;

  if (bounds.x.min > 0 || bounds.y.min > 0) {
    throw Error("Minimum bounds must not be greater than zero");
  }

  if (bounds.x.max < 0 || bounds.y.max < 0) {
    throw Error("Maximum bounds must not be less than zero");
  }

  if (bounds.x.wrap && (!isFinite(bounds.x.min) || !isFinite(bounds.x.max))) {
    throw Error("Wrapped bounds must define a minimum and maximum");
  }

  if (bounds.y.wrap && (!isFinite(bounds.y.min) || !isFinite(bounds.y.max))) {
    throw Error("Wrapped bounds must define a minimum and maximum");
  }

  if (Object.keys(regions).length === 0) {
    throw Error("No regions defined");
  }
}

function createDataObject(_ref5) {
  var initialData = _ref5.initialData;
  return deepEntries(initialData).reduce(function (result, _ref6) {
    var _result$x2;

    var _ref7 = _slicedToArray(_ref6, 3),
        x = _ref7[0],
        y = _ref7[1],
        state = _ref7[2];

    var region = Region.create({
      position: {
        x: x,
        y: y
      },
      type: state.type,
      seed: state.seed,
      mutations: state.mutations
    });
    result[x] = (_result$x2 = result[x]) !== null && _result$x2 !== void 0 ? _result$x2 : {};
    result[x][y] = region;
    return result;
  }, {});
}

function applyBounds(position, bounds) {
  var min = {
    x: bounds.x.min,
    y: bounds.y.min
  };
  var max = {
    x: bounds.x.max,
    y: bounds.y.max
  };
  var pos = clone(position);

  if (bounds.x.wrap) {
    pos.x = wrap(pos.x, bounds.x.min, bounds.x.max);
  }

  if (bounds.y.wrap) {
    pos.y = wrap(pos.y, bounds.y.min, bounds.y.max);
  }

  if (intersects(pos, min, max)) {
    return pos;
  }

  return undefined;
}

function parseOptions() {
  var _opt$x$min, _opt$x, _opt$x2, _opt$x$max, _opt$x3, _opt$x4, _opt$y$min, _opt$y, _opt$y2, _opt$y$max, _opt$y3, _opt$y4;

  var opt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var position = arguments.length > 1 ? arguments[1] : undefined;
  var def = {
    x: {
      min: position.x - 1,
      max: position.x + 1
    },
    y: {
      min: position.y - 1,
      max: position.y + 1
    }
  };
  return _objectSpread2(_objectSpread2({}, opt), {}, {
    x: {
      min: isObject(opt.x) ? Number((_opt$x$min = (_opt$x = opt.x) === null || _opt$x === void 0 ? void 0 : _opt$x.min) !== null && _opt$x$min !== void 0 ? _opt$x$min : def.x.min) : Number((_opt$x2 = opt.x) !== null && _opt$x2 !== void 0 ? _opt$x2 : def.x.min),
      max: isObject(opt.x) ? Number((_opt$x$max = (_opt$x3 = opt.x) === null || _opt$x3 === void 0 ? void 0 : _opt$x3.max) !== null && _opt$x$max !== void 0 ? _opt$x$max : def.x.max) : Number((_opt$x4 = opt.x) !== null && _opt$x4 !== void 0 ? _opt$x4 : def.x.max)
    },
    y: {
      min: isObject(opt.y) ? Number((_opt$y$min = (_opt$y = opt.y) === null || _opt$y === void 0 ? void 0 : _opt$y.min) !== null && _opt$y$min !== void 0 ? _opt$y$min : def.y.min) : Number((_opt$y2 = opt.y) !== null && _opt$y2 !== void 0 ? _opt$y2 : def.y.min),
      max: isObject(opt.y) ? Number((_opt$y$max = (_opt$y3 = opt.y) === null || _opt$y3 === void 0 ? void 0 : _opt$y3.max) !== null && _opt$y$max !== void 0 ? _opt$y$max : def.y.max) : Number((_opt$y4 = opt.y) !== null && _opt$y4 !== void 0 ? _opt$y4 : def.y.max)
    }
  });
}

function setRegion(data, position, options, _ref8) {
  var bounds = _ref8.bounds,
      regions = _ref8.regions,
      chooseRegion = _ref8.chooseRegion,
      seed = _ref8.seed;
  var pos = applyBounds(position, bounds);

  if (pos) {
    var _data$pos$x2;

    data[pos.x] = (_data$pos$x2 = data[pos.x]) !== null && _data$pos$x2 !== void 0 ? _data$pos$x2 : {};

    if (!data[pos.x][pos.y]) {
      var _options$type;

      var regionTypes = Object.keys(regions);
      var random = randomWithSeed([seed, pos]);
      var type = (_options$type = options.type) !== null && _options$type !== void 0 ? _options$type : chooseRegion({
        position: pos,
        regionTypes: regionTypes,
        random: random
      });

      if (Array.isArray(type)) {
        type = randomFrom(type, random)();
      }

      if (!regionTypes.includes(type)) {
        throw Error("Invalid region type \"".concat(type, "\" has not been defined"));
      }

      data[pos.x][pos.y] = Region.create({
        position: pos,
        type: type,
        seed: options.seed,
        mutations: options.mutations
      });
    }
  }
}

function initialize(data, position, _ref9) {
  var bounds = _ref9.bounds,
      regions = _ref9.regions,
      regionSize = _ref9.regionSize,
      seed = _ref9.seed;
  var pos = applyBounds(position, bounds);

  if (pos) {
    var region = data[pos.x][pos.y];
    region.data = DataSegment.create({
      size: regionSize,
      random: randomWithSeed([seed, region.seed]),
      regions: data,
      position: pos,
      bounds: bounds,
      mutations: region.mutations
    });

    if (isFunction(regions[region.type].init)) {
      regions[region.type].init({
        data: region.data,
        random: randomWithSeed([seed, region.seed])
      });
    }
  }
}

function mutate(data, position, _ref10) {
  var _data$pos$x3;

  var bounds = _ref10.bounds;
  var pos = applyBounds(position, bounds);
  var region = pos && ((_data$pos$x3 = data[pos.x]) === null || _data$pos$x3 === void 0 ? void 0 : _data$pos$x3[pos.y]);

  if (pos && region) {
    Object.entries(region.mutations).forEach(function (_ref11) {
      var _ref12 = _slicedToArray(_ref11, 2),
          key = _ref12[0],
          val = _ref12[1];

      var _key$split = key.split(","),
          _key$split2 = _slicedToArray(_key$split, 2),
          x = _key$split2[0],
          y = _key$split2[1];

      region.data.set(x, y, val);
    });
  }
}

var WorldRenderer = {
  /**
   * Creates a new world renderer object.
   *
   * @param   {World}  world
   * @param   {Object} config
   * @returns {Object}
   */
  create: function create(world, _ref) {
    var size = _ref.size,
        colors = _ref.colors;
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');
    var unit = size / world.regionSize;
    canvas.width = size * 3;
    canvas.height = size * 3;
    return {
      el: function el() {
        return canvas;
      },
      render: function render() {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        Object.values(Direction.NEIGHBORS).forEach(function (dir) {
          var x = world.position.x + dir.x;
          var y = world.position.y + dir.y;
          var region = world.getRegion({
            x: x,
            y: y
          });

          if (!region) {
            return;
          }

          var origin = {
            x: (dir.x + 1) * size,
            y: (dir.y + 1) * size
          };
          region.data.each(function (el, x, y) {
            var pos = {
              x: origin.x + x * unit,
              y: origin.y + y * unit
            };
            ctx.fillStyle = colors[el];
            ctx.fillRect(pos.x, pos.y, unit, unit);
          });
        });
      }
    };
  }
};

exports.$ = $;
exports.Direction = Direction;
exports.PatternMatcher = PatternMatcher;
exports.World = World;
exports.WorldRenderer = WorldRenderer;
exports.generateSeed = generateSeed;
